package com.tmax.openframe.variable.condition;

import ch.obermuhlner.math.big.BigDecimalMath;
import java.math.*;
import java.util.*;
import java.util.function.Predicate;
import lombok.*;

/** 
 * <p>This source code was generated by COBOL to JAVA migrator</p>
 */
public enum OIVPMAIN_WS_FIRST_TIME_FLAG_CONDITION {
    FIRST_TIME((WS_FIRST_TIME_FLAG) -> WS_FIRST_TIME_FLAG == 0, 0);
    Predicate<Integer> condition;
    Integer WS_FIRST_TIME_FLAG;

    private OIVPMAIN_WS_FIRST_TIME_FLAG_CONDITION(Predicate<Integer> condition,
            int repValue) {
        this.condition = condition;
        WS_FIRST_TIME_FLAG = repValue;
    }

    private OIVPMAIN_WS_FIRST_TIME_FLAG_CONDITION(Predicate<Integer> condition,
            long repValue) {
        this.condition = condition;
        WS_FIRST_TIME_FLAG = (int) repValue;
    }

    private OIVPMAIN_WS_FIRST_TIME_FLAG_CONDITION(Predicate<Integer> condition,
            double repValue) {
        this.condition = condition;
        WS_FIRST_TIME_FLAG = (int) repValue;
    }

    private OIVPMAIN_WS_FIRST_TIME_FLAG_CONDITION(Predicate<Integer> condition,
            String repValue) {
        this.condition = condition;
        WS_FIRST_TIME_FLAG = Integer.parseInt(repValue);
    }

    private OIVPMAIN_WS_FIRST_TIME_FLAG_CONDITION(Predicate<Integer> condition,
            BigDecimal repValue) {
        this.condition = condition;
        WS_FIRST_TIME_FLAG = repValue.intValue();
    }

    public boolean test(int t) {
        return this.condition.test(t);
    }

    public final int value() {
        return WS_FIRST_TIME_FLAG;
    }
}
